Index: LMDZ5/trunk/libf/phylmd/wake.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/wake.F	(revision 1907)
+++ LMDZ5/trunk/libf/phylmd/wake.F90	(revision 1992)
@@ -381,289 +1504,99 @@
 
       av_thu(i) = 0.
-      av_tu(i) =0.
-      av_qu(i) =0.
+      av_tu(i) = 0.
+      av_qu(i) = 0.
       av_thvu(i) = 0.
       av_dth(i) = 0.
       av_dq(i) = 0.
-      av_rho(i) =0.
-      av_dtdwn(i) =0.
+      av_rho(i) = 0.
+      av_dtdwn(i) = 0.
       av_dqdwn(i) = 0.
-      ENDDO
-c
-c Distance between wakes
-       DO i = 1,klon
-        LL(i) = (1-sqrt(sigmaw(i)))/sqrt(wdens(i))
-       ENDDO
-C Potential temperatures and humidity
-c----------------------------------------------------------
-      DO k =1,klev
-       DO i=1, klon 
-!        write(*,*)'wake 1',i,k,rd,te(i,k)
-        rho(i,k) = p(i,k)/(rd*te(i,k))
-!        write(*,*)'wake 2',rho(i,k)
-        IF(k .eq. 1) THEN
-!        write(*,*)'wake 3',i,k,rd,te(i,k)
-          rhoh(i,k) = ph(i,k)/(rd*te(i,k))
-!        write(*,*)'wake 4',i,k,rd,te(i,k)
-          zhh(i,k)=0
+    END IF
+  END DO
+  ! Potential temperatures and humidity
+  ! ----------------------------------------------------------
+
+  DO k = 1, klev
+    DO i = 1, klon
+      ! cc nrlmd       IF ( wk_adv(i)) THEN
+      IF (ok_qx_qw(i)) THEN
+        ! cc
+        rho(i, k) = p(i, k)/(rd*te(i,k))
+        IF (k==1) THEN
+          rhoh(i, k) = ph(i, k)/(rd*te(i,k))
+          zhh(i, k) = 0
         ELSE
-!          write(*,*)'wake 5',rd,(te(i,k)+te(i,k-1))
-          rhoh(i,k) = ph(i,k)*2./(rd*(te(i,k)+te(i,k-1)))
-!          write(*,*)'wake 6',(-rhoh(i,k)*RG)+zhh(i,k-1)
-          zhh(i,k)=(ph(i,k)-ph(i,k-1))/(-rhoh(i,k)*RG)+zhh(i,k-1)
-        ENDIF
-!          write(*,*)'wake 7',ppi(i,k)
-        the(i,k) = te(i,k)/ppi(i,k)
-        thu(i,k) = (te(i,k) - deltatw(i,k)*sigmaw(i))/ppi(i,k)
-        tu(i,k) = te(i,k) - deltatw(i,k)*sigmaw(i)
-        qu(i,k)  =  qe(i,k) - deltaqw(i,k)*sigmaw(i)
-!          write(*,*)'wake 8',(rd*(te(i,k)+deltatw(i,k)))
-        rhow(i,k) = p(i,k)/(rd*(te(i,k)+deltatw(i,k)))
-        dth(i,k) = deltatw(i,k)/ppi(i,k)
-       ENDDO
-      ENDDO
-        
-      DO k = 1, klev-1
-      DO i=1, klon 
-        IF(k.eq.1) THEN
-          N2(i,k)=0
-        ELSE
-          N2(i,k)=amax1(0.,-RG**2/the(i,k)*rho(i,k)*(the(i,k+1)-
-     $            the(i,k-1))/(p(i,k+1)-p(i,k-1)))
-        ENDIF
-        ZH(i,k)=(zhh(i,k)+zhh(i,k+1))/2
-
-        Cgw(i,k)=sqrt(N2(i,k))*ZH(i,k)
-        Tgw(i,k)=coefgw*Cgw(i,k)/LL(i)
-      ENDDO
-      ENDDO
-
-      DO i=1, klon
-      N2(i,klev)=0
-      ZH(i,klev)=0
-      Cgw(i,klev)=0
-      Tgw(i,klev)=0
-      ENDDO
-
-c  Calcul de la masse volumique moyenne de la colonne   (bdlmd)
-c-----------------------------------------------------------------
-
-      DO k=1,klev
-       DO i=1, klon
-        epaisseur1(i,k)=0.
-        epaisseur2(i,k)=0.
-       ENDDO
-      ENDDO
-
-      DO i=1, klon
-      epaisseur1(i,1)= -(ph(i,2)-ph(i,1))/(rho(i,1)*rg)+1.
-      epaisseur2(i,1)= -(ph(i,2)-ph(i,1))/(rho(i,1)*rg)+1.
-      rhow_moyen(i,1) = rhow(i,1)
-      ENDDO
-
-      DO k = 2, klev
-      DO i=1, klon
-        epaisseur1(i,k)= -(ph(i,k+1)-ph(i,k))/(rho(i,k)*rg) +1.
-        epaisseur2(i,k)=epaisseur2(i,k-1)+epaisseur1(i,k)
-        rhow_moyen(i,k) = (rhow_moyen(i,k-1)*epaisseur2(i,k-1)+
-     $                 rhow(i,k)*epaisseur1(i,k))/epaisseur2(i,k)
-      ENDDO
-      ENDDO
-
-C
-C Choose an integration bound well above wake top
-c-----------------------------------------------------------------
-c
-C       Pupper = 50000.  ! melting level
-c       Pupper = 60000.
-c       Pupper = 80000.  ! essais pour case_e
-       DO i = 1,klon
-        Pupper(i) = 0.6*ph(i,1)
-        Pupper(i) = max(Pupper(i), 45000.)
-ccc        Pupper(i) = 60000.
-       ENDDO
-
-C
-C    Determine Wake top pressure (Ptop) from buoyancy integral
-C    --------------------------------------------------------
-c
-c-1/ Pressure of the level where dth becomes less than delta_t_min.
-
-      DO i=1,klon
-      ptop_provis(i)=ph(i,1)
-      ENDDO
-      DO k= 2,klev
-      DO i=1,klon
-c
-cIM v3JYG; ptop_provis(i).LT. ph(i,1)
-c
-        IF (dth(i,k) .GT. -delta_t_min .and.
-     $      dth(i,k-1).LT. -delta_t_min .and.
-     $      ptop_provis(i).EQ. ph(i,1)) THEN
-          ptop_provis(i) = ((dth(i,k)+delta_t_min)*p(i,k-1)
-     $          - (dth(i,k-1)+delta_t_min)*p(i,k)) /
-     $          (dth(i,k) - dth(i,k-1))
-        ENDIF
-      ENDDO
-      ENDDO
-
-c-2/ dth integral
-
-      DO i=1,klon
-      sum_dth(i) = 0.
-      dthmin(i) = -delta_t_min
-      z(i) = 0.
-      ENDDO
-
-      DO k = 1,klev
-      DO i=1,klon
-        dz(i) = -(amax1(ph(i,k+1),ptop_provis(i))-Ph(i,k))/(rho(i,k)*rg)
-        IF (dz(i) .gt. 0) THEN
-          z(i) = z(i)+dz(i)
-          sum_dth(i) = sum_dth(i) + dth(i,k)*dz(i)
-          dthmin(i) = amin1(dthmin(i),dth(i,k))
-        ENDIF
-      ENDDO
-      ENDDO
-
-c-3/ height of triangle with area= sum_dth and base = dthmin
-
-      DO i=1,klon
-      hw0(i) = 2.*sum_dth(i)/amin1(dthmin(i),-0.5)
-      hw0(i) = amax1(hwmin,hw0(i))
-      ENDDO
-
-c-4/ now, get Ptop
-
-      DO i=1,klon
-      z(i) = 0.
-      ptop(i) = ph(i,1)
-      ENDDO
-
-      DO k = 1,klev
-      DO i=1,klon
-        dz(i) = amin1(-(ph(i,k+1)-ph(i,k))/(rho(i,k)*rg),hw0(i)-z(i))
-        IF (dz(i) .gt. 0) THEN
-         z(i) = z(i)+dz(i)
-         ptop(i) = ph(i,k)-rho(i,k)*rg*dz(i)
-        ENDIF
-      ENDDO
-      ENDDO
-
-
-C-5/ Determination de ktop et kupper
-
-      DO k=klev,1,-1
-      DO i=1,klon
-        IF (ph(i,k+1) .lt. ptop(i)) ktop(i)=k
-        IF (ph(i,k+1) .lt. pupper(i)) kupper(i)=k
-      ENDDO
-      ENDDO
-
-c      On evite kupper = 1 et kupper = klev
-      DO i=1,klon
-        kupper(i) = max(kupper(i),2)
-        kupper(i) = min(kupper(i),klev-1)
-      ENDDO
-
-
-c-6/ Correct ktop and ptop
-
-      DO i = 1,klon
-        ptop_new(i)=ptop(i)
-      ENDDO
-      DO k= klev,2,-1
-      DO i=1,klon
-        IF (k .LE. ktop(i) .and.
-     $      ptop_new(i) .EQ. ptop(i) .and.
-     $      dth(i,k) .GT. -delta_t_min .and.
-     $      dth(i,k-1).LT. -delta_t_min) THEN
-          ptop_new(i) = ((dth(i,k)+delta_t_min)*p(i,k-1)
-     $          - (dth(i,k-1)+delta_t_min)*p(i,k)) /
-     $          (dth(i,k) - dth(i,k-1))
-        ENDIF
-      ENDDO
-      ENDDO
-
-      DO i=1,klon
-        ptop(i) = ptop_new(i)
-      ENDDO
-
-      DO k=klev,1,-1
-      DO i=1,klon
-        IF (ph(i,k+1) .lt. ptop(i)) ktop(i)=k
-      ENDDO
-      ENDDO
-c
-c-5/ Set deltatw & deltaqw to 0 above kupper
-c
-      DO k = 1,klev
-      DO i=1,klon
-       IF (k.GE. kupper(i)) THEN
-        deltatw(i,k) = 0.
-        deltaqw(i,k) = 0.
-       ENDIF
-      ENDDO
-      ENDDO
-c
-C
-C Vertical gradient of LS omega
-C
-      DO k = 1,klev
-      DO i=1,klon
-       IF (k.LE. kupper(i)) THEN
-        dp_omgb(i,k) = (omgb(i,k+1) - omgb(i,k))/(ph(i,k+1)-ph(i,k))
-       ENDIF
-      ENDDO
-      ENDDO
-C
-C Integrals (and wake top level number)
-C --------------------------------------
-C
-C Initialize sum_thvu to 1st level virt. pot. temp.
-
-      DO i=1,klon
+          rhoh(i, k) = ph(i, k)*2./(rd*(te(i,k)+te(i,k-1)))
+          zhh(i, k) = (ph(i,k)-ph(i,k-1))/(-rhoh(i,k)*rg) + zhh(i, k-1)
+        END IF
+        the(i, k) = te(i, k)/ppi(i, k)
+        thu(i, k) = (te(i,k)-deltatw(i,k)*sigmaw(i))/ppi(i, k)
+        tu(i, k) = te(i, k) - deltatw(i, k)*sigmaw(i)
+        qu(i, k) = qe(i, k) - deltaqw(i, k)*sigmaw(i)
+        rhow(i, k) = p(i, k)/(rd*(te(i,k)+deltatw(i,k)))
+        dth(i, k) = deltatw(i, k)/ppi(i, k)
+      END IF
+    END DO
+  END DO
+
+  ! Integrals (and wake top level number)
+  ! -----------------------------------------------------------
+
+  ! Initialize sum_thvu to 1st level virt. pot. temp.
+
+  DO i = 1, klon
+    ! cc nrlmd       IF ( wk_adv(i)) THEN
+    IF (ok_qx_qw(i)) THEN
+      ! cc
       z(i) = 1.
       dz(i) = 1.
-      sum_thvu(i) =  thu(i,1)*(1.+eps*qu(i,1))*dz(i)
+      sum_thvu(i) = thu(i, 1)*(1.+eps*qu(i,1))*dz(i)
       sum_dth(i) = 0.
-      ENDDO
-
-      DO k = 1,klev
-      DO i=1,klon
+    END IF
+  END DO
+
+  DO k = 1, klev
+    DO i = 1, klon
+      ! cc nrlmd       IF ( wk_adv(i)) THEN
+      IF (ok_qx_qw(i)) THEN
+        ! cc
         dz(i) = -(amax1(ph(i,k+1),ptop(i))-ph(i,k))/(rho(i,k)*rg)
-        IF (dz(i) .GT. 0) THEN
-         z(i) = z(i)+dz(i)
-         sum_thu(i) = sum_thu(i) + thu(i,k)*dz(i)
-         sum_tu(i) = sum_tu(i) + tu(i,k)*dz(i)
-         sum_qu(i) = sum_qu(i) + qu(i,k)*dz(i)
-         sum_thvu(i) = sum_thvu(i) + thu(i,k)*(1.+eps*qu(i,k))*dz(i)
-         sum_dth(i) = sum_dth(i) + dth(i,k)*dz(i)
-         sum_dq(i) = sum_dq(i) + deltaqw(i,k)*dz(i)
-         sum_rho(i) = sum_rho(i) + rhow(i,k)*dz(i)
-         sum_dtdwn(i) = sum_dtdwn(i) + dtdwn(i,k)*dz(i)
-         sum_dqdwn(i) = sum_dqdwn(i) + dqdwn(i,k)*dz(i)
-        ENDIF
-      ENDDO
-      ENDDO
-c
-      DO i=1,klon
-        hw0(i) = z(i)
-      ENDDO
-c
-C
-C 2.1 - WAPE and mean forcing computation
-C ---------------------------------------
-C
-C ---------------------------------------
-C
-C Means
-
-      DO i=1,klon
+        IF (dz(i)>0) THEN
+          z(i) = z(i) + dz(i)
+          sum_thu(i) = sum_thu(i) + thu(i, k)*dz(i)
+          sum_tu(i) = sum_tu(i) + tu(i, k)*dz(i)
+          sum_qu(i) = sum_qu(i) + qu(i, k)*dz(i)
+          sum_thvu(i) = sum_thvu(i) + thu(i, k)*(1.+eps*qu(i,k))*dz(i)
+          sum_dth(i) = sum_dth(i) + dth(i, k)*dz(i)
+          sum_dq(i) = sum_dq(i) + deltaqw(i, k)*dz(i)
+          sum_rho(i) = sum_rho(i) + rhow(i, k)*dz(i)
+          sum_dtdwn(i) = sum_dtdwn(i) + dtdwn(i, k)*dz(i)
+          sum_dqdwn(i) = sum_dqdwn(i) + dqdwn(i, k)*dz(i)
+        END IF
+      END IF
+    END DO
+  END DO
+
+  DO i = 1, klon
+    ! cc nrlmd       IF ( wk_adv(i)) THEN
+    IF (ok_qx_qw(i)) THEN
+      ! cc
+      hw0(i) = z(i)
+    END IF
+  END DO
+
+  ! - WAPE and mean forcing computation
+  ! -------------------------------------------------------------
+
+  ! Means
+
+  DO i = 1, klon
+    ! cc nrlmd       IF ( wk_adv(i)) THEN
+    IF (ok_qx_qw(i)) THEN
+      ! cc
       av_thu(i) = sum_thu(i)/hw0(i)
       av_tu(i) = sum_tu(i)/hw0(i)
       av_qu(i) = sum_qu(i)/hw0(i)
       av_thvu(i) = sum_thvu(i)/hw0(i)
-c      av_thve = sum_thve/hw0
       av_dth(i) = sum_dth(i)/hw0(i)
       av_dq(i) = sum_dq(i)/hw0(i)
